diff --git a/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java b/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
index 5a5c1cac2..7cf290f5a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -1,11 +1,10 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.BlockPortal;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.Nullable;
 
@@ -13,6 +12,7 @@ import java.util.Random;
 
 public class PortalHandler
 {
+    private final Random rand;
 
     public PortalHandler()
     {
@@ -32,16 +32,16 @@ public class PortalHandler
         int searchRadius = 128;
         double lowestEntityDistanceSquaredXZ = -1D;
         double lowestEntityDistanceSquaredY = -1D;
-        int targetPortalId;
+        Block<? extends BlockLogicPortal> targetPortal;
         int closestPortalX = 0;
         int closestPortalY = 0;
         int closestPortalZ = 0;
         int entityBlockX = MathHelper.floor(entity.x);
         int entityBlockZ = MathHelper.floor(entity.z);
-        
+
         WorldType oldWorldType = oldDim.getDimensionData(world).getWorldType();
         WorldType newWorldType = newDim.getDimensionData(world).getWorldType();
-        
+
         double entityPosYScaled = entity.y - entity.heightOffset;
         int oldDimRangeY = oldWorldType.getMaxPortalY() - oldWorldType.getMinPortalY();
         entityPosYScaled -= oldWorldType.getMinPortalY();
@@ -53,13 +53,13 @@ public class PortalHandler
 
         if (newDim.homeDim == null)
         {
-        	targetPortalId = oldDim.portalBlockId;
+        	targetPortal = oldDim.portalBlock;
         }
         else
         {
-        	targetPortalId = newDim.portalBlockId;
+        	targetPortal = newDim.portalBlock;
         }
-        
+
         // Attempt to find closest portal along the xz plane
         for(int dx = entityBlockX - searchRadius; dx <= entityBlockX + searchRadius; dx++)
         {
@@ -69,18 +69,18 @@ public class PortalHandler
                 double zEntityDistance = ((double)dz + 0.5D) - entity.z;
                 for(int dy = newWorldType.getMaxPortalY() - 1; dy >= newWorldType.getMinPortalY(); dy--)
                 {
-                    if(world.getBlockId(dx, dy, dz) != targetPortalId)
+                    if(world.getBlock(dx, dy, dz) != targetPortal)
                     {
                         continue;
                     }
 
-                    if (portalColor != null && targetPortalId > 0 && ((BlockPortal)Blocks.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                    if (portalColor != null && targetPortal != null && targetPortal.getLogic().getColor(world, dx, dy, dz) != portalColor) {
                         continue;
                     }
-                    
+
                     // Find the bottom portal block of the portal
-                    for(; world.getBlockId(dx, dy - 1, dz) == targetPortalId; dy--);
-                    
+                    for(; world.getBlock(dx, dy - 1, dz) == targetPortal; dy--);
+
 //                    double yEntityDistance = ((double)dy + 0.5D) - entityPosYScaled;
                     double entityDistanceSquared = xEntityDistance * xEntityDistance /*+ yEntityDistance * yEntityDistance*/ + zEntityDistance * zEntityDistance;
                     if(lowestEntityDistanceSquaredXZ < 0.0D || entityDistanceSquared < lowestEntityDistanceSquaredXZ)
@@ -105,16 +105,16 @@ public class PortalHandler
                 for (int dz = cz - 1; dz <= cz + 1; dz++) {
                     double zEntityDistance = ((double) dz + 0.5D) - entity.z;
                     for (int dy = newWorldType.getMaxPortalY() - 1; dy >= newWorldType.getMinPortalY(); dy--) {
-                        if (world.getBlockId(dx, dy, dz) != targetPortalId) {
+                        if (world.getBlock(dx, dy, dz) != targetPortal) {
                             continue;
                         }
 
-                        if (portalColor != null && targetPortalId > 0 && ((BlockPortal) Blocks.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                        if (portalColor != null && targetPortal != null && targetPortal.getLogic().getColor(world, dx, dy, dz) != portalColor) {
                             continue;
                         }
 
                         // Find the bottom portal block of the portal
-                        for (; world.getBlockId(dx, dy - 1, dz) == targetPortalId; dy--) ;
+                        for (; world.getBlock(dx, dy - 1, dz) == targetPortal; dy--) ;
 
                         double yEntityDistance = ((double) dy + 0.5D) - entityPosYScaled;
                         double entityDistanceSquared = xEntityDistance * xEntityDistance + yEntityDistance * yEntityDistance + zEntityDistance * zEntityDistance;
@@ -137,26 +137,26 @@ public class PortalHandler
             double newEntityX = (double)portalX + 0.5D;
             double newEntityY = (double)portalY + 0.5D;
             double newEntityZ = (double)portalZ + 0.5D;
-            if(world.getBlockId(portalX - 1, portalY, portalZ) == targetPortalId)
+            if(world.getBlock(portalX - 1, portalY, portalZ) == targetPortal)
             {
                 newEntityX -= 0.5D;
             }
-            if(world.getBlockId(portalX + 1, portalY, portalZ) == targetPortalId)
+            if(world.getBlock(portalX + 1, portalY, portalZ) == targetPortal)
             {
                 newEntityX += 0.5D;
             }
-            if(world.getBlockId(portalX, portalY, portalZ - 1) == targetPortalId)
+            if(world.getBlock(portalX, portalY, portalZ - 1) == targetPortal)
             {
                 newEntityZ -= 0.5D;
             }
-            if(world.getBlockId(portalX, portalY, portalZ + 1) == targetPortalId)
+            if(world.getBlock(portalX, portalY, portalZ + 1) == targetPortal)
             {
                 newEntityZ += 0.5D;
             }
             entity.moveTo(newEntityX, newEntityY - 0.5f, newEntityZ, entity.yRot, 0.0F);
             entity.xd = entity.yd = entity.zd = 0.0D;
             return true;
-        } 
+        }
         else
         {
             return false;
@@ -188,20 +188,20 @@ public class PortalHandler
         int closestPortalZ = blockZ;
         int k1 = 0;
         int l1 = rand.nextInt(4);
-        int targetPortalFrameId;
-        int targetPortalId;
-        
+        Block<?> targetPortalFrame;
+        Block<? extends BlockLogicPortal> targetPortal;
+
         if (newDim.homeDim == null)
         {
-        	targetPortalFrameId = ((BlockPortal) Blocks.blocksList[oldDim.portalBlockId]).portalFrameId;
-        	targetPortalId = oldDim.portalBlockId;
+        	targetPortalFrame = oldDim.portalBlock.getLogic().portalFrame;
+        	targetPortal = oldDim.portalBlock;
         }
         else
         {
-        	targetPortalFrameId = ((BlockPortal)Blocks.blocksList[newDim.portalBlockId]).portalFrameId;
-        	targetPortalId = newDim.portalBlockId;
+        	targetPortalFrame = newDim.portalBlock.getLogic().portalFrame;
+        	targetPortal = newDim.portalBlock;
         }
-        
+
         for(int dx = blockX - portalSearchRadius; dx <= blockX + portalSearchRadius; dx++)
         {
             double xEntityDistance = ((double)dx + 0.5D) - entity.x;
@@ -340,7 +340,7 @@ label1:
                         int y = portalY + j7;
                         int z = (portalZ + (i6 - 1) * frameZMult) - i5 * frameXMult;
                         boolean flag = j7 < 0;
-                        world.setBlockWithNotify(x, y, z, flag ? targetPortalFrameId : 0);
+                        world.setBlockWithNotify(x, y, z, flag ? targetPortalFrame.id() : 0);
                     }
 
                 }
@@ -359,12 +359,12 @@ label1:
                     int lookupY = portalY + yOffset;
                     int lookupZ = portalZ + (xzOffset - 1) * frameZMult;
                     boolean isPortalBorder = xzOffset == 0 || xzOffset == 3 || yOffset == -1 || yOffset == 3;
-                    world.setBlockWithNotify(lookupX, lookupY, lookupZ, isPortalBorder ? targetPortalFrameId : 0);
+                    world.setBlockWithNotify(lookupX, lookupY, lookupZ, isPortalBorder ? targetPortalFrame.id() : 0);
                 }
 
             }
-            
-            ((BlockPortal)Blocks.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
+
+            targetPortal.getLogic().tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
 
             world.noNeighborUpdate = false;
             for(int k6 = 0; k6 < 4; k6++)
@@ -383,6 +383,4 @@ label1:
 
         return true;
     }
-
-    private Random rand;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 5921fe9e5..2e9befd64 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.BlockBed;
+import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -281,7 +281,7 @@ public final class SpawnerMobs
 								Node pathPoint = pathEntity.last();
                                 boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(player.x, player.y + 1.5f, player.z), Vec3.getTempVec3(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
 								if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
-									ChunkCoordinates pos = BlockBed.getNearestEmptyChunkCoordinates(world, MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z), 1);
+									ChunkCoordinates pos = BlockLogicBed.getNearestEmptyChunkCoordinates(world, MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z), 1);
 									if(pos == null) {
 										pos = new ChunkCoordinates(x, spawnY + 1, z);
 									}
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index ea80c584b..5c6241087 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -445,7 +445,7 @@ public class World implements WorldSource {
     }
 
     @Override
-    public Block getBlock(int x, int y, int z) {
+    public @Nullable Block<?> getBlock(int x, int y, int z) {
         return Blocks.getBlock(getBlockId(x, y, z));
     }
 
@@ -738,7 +738,7 @@ public class World implements WorldSource {
             return Material.air;
         } else
         {
-            return Blocks.blocksList[l].blockMaterial;
+            return Blocks.blocksList[l].getMaterial();
         }
     }
 
@@ -883,7 +883,7 @@ public class World implements WorldSource {
         {
             return;
         }
-        Block block = Blocks.blocksList[getBlockId(x, y, z)];
+        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block != null)
         {
             block.onNeighborBlockChange(this, x, y, z, blockId);
@@ -1169,7 +1169,7 @@ public class World implements WorldSource {
         int blockStartZ = MathHelper.floor(start.z);
         int id = getBlockId(blockStartX, blockStartY, blockStartZ);
         int meta = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
-        Block block = Blocks.blocksList[id];
+        Block<?> block = Blocks.blocksList[id];
         if(
             (
                 !ignoreNonColliderBlocks ||
@@ -1307,7 +1307,7 @@ public class World implements WorldSource {
                 blockStartZ--;
                 vec32.z++;
             }
-            Block block1 = getBlock(blockStartX, blockStartY, blockStartZ);
+            Block<?> block1 = getBlock(blockStartX, blockStartY, blockStartZ);
             int metadata1 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
             if(
                 (!ignoreNonColliderBlocks || (block1 == null) || ((useSelectorBoxes ? block1.getSelectedBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) : block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ)) != null)) && (block1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids))
@@ -1341,7 +1341,7 @@ public class World implements WorldSource {
         }
     }
     
-    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, Block block, EnumBlockSoundEffectType soundType)
+    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, Block<?> block, EnumBlockSoundEffectType soundType)
     {
         if (block == null) return;
 
@@ -1508,7 +1508,7 @@ public class World implements WorldSource {
                 }
                 for(int dy = minY - 1; dy <= maxY; dy++)
                 {
-                    Block block = getBlock(dx, dy, dz);
+                    Block<?> block = getBlock(dx, dy, dz);
                     if(block != null)
                     {
                         int metadata = getBlockMetadata(dx, dy, dz);
@@ -1554,11 +1554,11 @@ public class World implements WorldSource {
                 }
                 for(int dy = minY - 1; dy <= maxY; dy++)
                 {
-                    Block block = Blocks.blocksList[getBlockId(dx, dy, dz)];
+                    Block<?> block = Blocks.blocksList[getBlockId(dx, dy, dz)];
                     if(block != null && block.isSolidRender())
                     {
                         // ignore mesh blocks if entity is instance of an item
-                        if(!(entity instanceof EntityItem && (block.id == Blocks.MESH.id || block.id == Blocks.SPIKES.id || block.id == Blocks.MOBSPAWNER.id)))
+                        if(!(entity instanceof EntityItem && (block.id() == Blocks.MESH.id() || block.id() == Blocks.SPIKES.id() || block.id() == Blocks.MOBSPAWNER.id())))
                             block.getCollidingBoundingBoxes(this, dx, dy, dz, axisalignedbb, collidingBoundingBoxes);
                     }
                 }
@@ -1571,7 +1571,7 @@ public class World implements WorldSource {
         List<Entity> list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.grow(d, d, d));
         for(int j2 = 0; j2 < list.size(); j2++)
         {
-            AABB aabb = ((Entity)list.get(j2)).getBb();
+            AABB aabb = list.get(j2).getBb();
             if(aabb != null && aabb.intersects(axisalignedbb))
             {
                 collidingBoundingBoxes.add(aabb);
@@ -1621,7 +1621,7 @@ public class World implements WorldSource {
         while(y > 0)
         {
             int id = chunk.getBlockID(x, y, z);
-            Material material = id != 0 ? Blocks.blocksList[id].blockMaterial : Material.air;
+            Material material = id != 0 ? Blocks.blocksList[id].getMaterial() : Material.air;
             if(!material.blocksMotion() && !material.isLiquid())
             {
                 y--;
@@ -1642,8 +1642,8 @@ public class World implements WorldSource {
         z &= (Chunk.CHUNK_SIZE_Z - 1);
         while(y > 0)
         {
-            Block block = Blocks.getBlock(chunk.getBlockID(x, y, z));
-            Material material = block != null ? block.blockMaterial : Material.air;
+            Block<?> block = Blocks.getBlock(chunk.getBlockID(x, y, z));
+            Material material = block != null ? block.getMaterial() : Material.air;
             if(!material.blocksMotion())
             {
                 y--;
@@ -1888,7 +1888,7 @@ public class World implements WorldSource {
 		for(int x = minX; x <= maxX; x++) {
 			for(int y = minY; y <= maxY; y++) {
 				for(int z = minZ; z <= maxZ; z++) {
-					Block block = Blocks.blocksList[getBlockId(x, y, z)];
+                    Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
 					if(block != null) {
 						return true;
 					}
@@ -1920,8 +1920,8 @@ public class World implements WorldSource {
 		for(int x = minX; x <= maxX; x++) {
 			for(int y = minY; y <= maxY; y++) {
 				for(int z = minZ; z <= maxZ; z++) {
-					Block block = Blocks.blocksList[getBlockId(x, y, z)];
-					if(block != null && block.blockMaterial.isLiquid()) {
+                    Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
+					if(block != null && block.getMaterial().isLiquid()) {
 						return true;
 					}
 				}
@@ -1956,7 +1956,7 @@ public class World implements WorldSource {
             {
                 for(int i2 = i1; i2 < j1; i2++)
                 {
-                    Block block = Blocks.blocksList[getBlockId(k1, l1, i2)];
+                    Block<?> block = Blocks.blocksList[getBlockId(k1, l1, i2)];
                     if(block == null || !isMaterialInBB(aabb, material))
                     {
                         continue;
@@ -1994,11 +1994,11 @@ public class World implements WorldSource {
             {
                 for(int _z = minZ_i; _z < maxZ_i; _z++)
                 {
-                    Block block = Blocks.blocksList[getBlockId(_x, _y, _z)];
+                    Block<?> block = Blocks.blocksList[getBlockId(_x, _y, _z)];
                     if(block != null) {
                         boolean isMaterial = false;
                         for (Material m : materials){
-                            if (block.blockMaterial == m) {
+                            if (block.getMaterial() == m) {
                                 isMaterial = true;
                                 break;
                             }
@@ -2031,8 +2031,8 @@ public class World implements WorldSource {
             {
                 for(int i2 = i1; i2 < j1; i2++)
                 {
-                    Block block = Blocks.blocksList[getBlockId(k1, l1, i2)];
-                    if(block == null || block.blockMaterial != material)
+                    Block<?> block = Blocks.blocksList[getBlockId(k1, l1, i2)];
+                    if(block == null || block.getMaterial() != material)
                     {
                         continue;
                     }
@@ -2108,7 +2108,7 @@ public class World implements WorldSource {
         x += side.getOffsetX();
         y += side.getOffsetY();
         z += side.getOffsetZ();
-        if(getBlockId(x, y, z) == Blocks.FIRE.id)
+        if(getBlockId(x, y, z) == Blocks.FIRE.id())
         {
             playBlockEvent(entityplayer, LevelListener.EVENT_FIRE_EXTINGUISH, x, y, z, 0);
             setBlockWithNotify(x, y, z, 0);
@@ -2186,7 +2186,7 @@ public class World implements WorldSource {
     @Override
     public boolean isBlockOpaqueCube(int x, int y, int z)
     {
-        Block block = Blocks.blocksList[getBlockId(x, y, z)];
+        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -2198,7 +2198,7 @@ public class World implements WorldSource {
 
     public boolean canPlaceOnSurfaceOfBlock(int x, int y, int z)
     {
-        Block block = Blocks.blocksList[getBlockId(x, y, z)];
+        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -2211,13 +2211,13 @@ public class World implements WorldSource {
     @Override
     public boolean isBlockNormalCube(int x, int y, int z)
     {
-        Block block = Blocks.blocksList[getBlockId(x, y, z)];
+        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
         } else
         {
-            return block.blockMaterial.isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, x, y, z);
+            return block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, x, y, z);
         }
     }
     
@@ -2542,7 +2542,7 @@ public class World implements WorldSource {
             int rx = (x + rand.nextInt(radius)) - rand.nextInt(radius);
             int ry = (y + rand.nextInt(radius)) - rand.nextInt(radius);
             int rz = (z + rand.nextInt(radius)) - rand.nextInt(radius);
-            Block block = getBlock(rx, ry, rz);
+            Block<?> block = getBlock(rx, ry, rz);
             if (block != null) {
                 block.animationTick(this, rx, ry, rz, random);
             }
@@ -2571,13 +2571,13 @@ public class World implements WorldSource {
         return entityBuffer;
     }
 
-    public List<Entity> getEntitiesWithinAABB(Class<? extends Entity> ofClass, AABB aabb)
+    public <T extends Entity> @NotNull List<@NotNull T> getEntitiesWithinAABB(Class<T> ofClass, AABB aabb)
     {
         int minX = MathHelper.floor((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
         int maxX = MathHelper.floor((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
         int minZ = MathHelper.floor((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
         int maxZ = MathHelper.floor((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
-        List<Entity> entities = new ArrayList<>();
+        List<@NotNull T> entities = new ArrayList<>();
         for(int x = minX; x <= maxX; x++)
         {
             for(int z = minZ; z <= maxZ; z++)
@@ -2654,8 +2654,8 @@ public class World implements WorldSource {
     		return false;
     	}
         int j1 = getBlockId(x, y, z);
-        Block block = Blocks.blocksList[j1];
-        Block block1 = Blocks.blocksList[blockId];
+        Block<?> block = Blocks.blocksList[j1];
+        Block<?> block1 = Blocks.blocksList[blockId];
         AABB axisalignedbb = block1.getCollisionBoundingBoxFromPool(this, x, y, z);
         if(flag)
         {
@@ -2705,7 +2705,7 @@ public class World implements WorldSource {
     }
 
     public boolean getDirectSignal(int x, int y, int z, Side side) {
-        Block block = getBlock(x, y, z);
+        Block<?> block = getBlock(x, y, z);
         if (block == null) return false;
         return block.getDirectSignal(this, x, y, z, side);
     }
@@ -2725,7 +2725,7 @@ public class World implements WorldSource {
     }
 
     public boolean getSignal(int x, int y, int z, Side side) {
-        Block block = getBlock(x, y, z);
+        Block<?> block = getBlock(x, y, z);
         if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE) {
             return hasDirectSignal(x, y, z);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 4e4b90303..208a53557 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -6,13 +6,14 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.season.SeasonManager;
+import org.jetbrains.annotations.Nullable;
 
 public interface WorldSource
 {
 
     int getBlockId(int x, int y, int z);
 
-    Block getBlock(int x, int y, int z);
+    @Nullable Block<?> getBlock(int x, int y, int z);
 
     TileEntity getBlockEntity(int x, int y, int z);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index 38a5e5c08..ebda87dcb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -41,8 +41,8 @@ public class Biome
     public Biome(String key)
     {
     	this.translationKey = "biome." + key; 
-        topBlock = (short) Blocks.GRASS.id;
-        fillerBlock = (short)Blocks.DIRT.id;
+        topBlock = (short) Blocks.GRASS.id();
+        fillerBlock = (short)Blocks.DIRT.id();
         spawnableMonsterList = new ArrayList<>();
         spawnableCreatureList = new ArrayList<>();
         spawnableWaterCreatureList = new ArrayList<>();
@@ -66,10 +66,10 @@ public class Biome
     {
         if(random.nextInt(10) == 0)
         {
-            return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id);
+            return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
         } else
         {
-            return new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 4);
+            return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java
index b3f418d72..a69354919 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java
@@ -24,9 +24,9 @@ public class BiomeBirchForest extends Biome
 
         if(random.nextInt(10) == 0)
         {
-            return new WorldFeatureTreeTall(Blocks.LEAVES_BIRCH.id, Blocks.LOG_BIRCH.id);
+            return new WorldFeatureTreeTall(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id());
         } else
-            return new WorldFeatureTree(Blocks.LEAVES_BIRCH.id, Blocks.LOG_BIRCH.id, 8);
+            return new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 8);
 
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java
index 98f0e018f..48e72e0ad 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java
@@ -20,6 +20,6 @@ public class BiomeBorealForest extends Biome
     @Override
 	public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        return new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
+        return new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
index 4477c5b1e..033c563fa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
@@ -22,10 +22,10 @@ public class BiomeCaatinga extends Biome
     {
         if(random.nextInt(3) != 0)
         {
-            return new WorldFeatureTreeShrub(Blocks.LEAVES_THORN.id, Blocks.LOG_OAK.id);
+            return new WorldFeatureTreeShrub(Blocks.LEAVES_THORN.id(), Blocks.LOG_OAK.id());
         } else
         {
-            return new WorldFeatureTreeThorn(4, Blocks.LOG_THORN.id, 0, Blocks.LEAVES_THORN.id, 0);
+            return new WorldFeatureTreeThorn(4, Blocks.LOG_THORN.id(), 0, Blocks.LEAVES_THORN.id(), 0);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
index 8da8c2cab..969bf77f6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
@@ -23,16 +23,16 @@ public class BiomeForest extends Biome
     {
         if(random.nextInt(5) == 0)
         {
-            return new WorldFeatureTree(Blocks.LEAVES_BIRCH.id, Blocks.LOG_BIRCH.id, 5);
+            return new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 5);
         }
         if(random.nextInt(3) == 0)
         {
-            return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id);
+            return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
         } else
         {
             if(random.nextInt(25) == 0)
-                return new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK_MOSSY.id, 4);
-            return new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 4);
+                return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK_MOSSY.id(), 4);
+            return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java
index a8be3d53f..cbb17769a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java
@@ -23,6 +23,6 @@ public class BiomeOutback extends Biome
     @Override
 	public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        return new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id, Blocks.LOG_EUCALYPTUS.id);
+        return new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
index d7e32c07b..0d858c304 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
@@ -15,6 +15,6 @@ public class BiomePlains extends Biome
     @Override
     public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        return new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id, Blocks.LOG_EUCALYPTUS.id);
+        return new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
     }
 }
